//########################################################################
//#  Node MCU MQTT Example                                               #
//#  More info can be found at                    www.electronhacks.com  #
//########################################################################


//##### Declarations and Variables #####
#include <PubSubClient.h>
#include <ESP8266WiFi.h>
char vInp13 = 0;
int vA0 = 0;
int iA0 = 0;
int Counter = 0;
String rx;
int  rxLength = 0;
//Configuration, enter your own values here
char ssid[]         = "ssid";              // your network name also called SSID
char password[]     = "password";          // your network password
char server[]       = "192.168.1.165";      // MQTT Server IP or machine name
char topic[]        = "test/";        // MQTT Topic
char mQTTID[]       = "ESPdemo";     // MQTT ID. Make this unique for each device connecting to the MQTT Broker or they will disconnect eachother!
char mQTTUser[]     = "user";             // MQTT UserName (See below for modification if you don't use user and password)
char mQTTPassword[] = "pass";             // MQTT Password (See below for modification if you don't use user and password)

WiFiClient wifiClient;
PubSubClient client(server, 1883, callback, wifiClient);


//##### Void Setup, runs once on startup #####
void setup()
{
  pinMode(16, OUTPUT);
  pinMode(12, INPUT_PULLUP);
  
  Serial.begin(115200);
  Serial.print("Attempting to connect to Network named: ");   
  Serial.println(ssid);   
  WiFi.begin(ssid, password);  
  while ( WiFi.status() != WL_CONNECTED) 
  {
    Serial.print(".");     // print dots while we wait to connect
    delay(300);
  }
  
  Serial.println("\nYou're connected to the network");
  Serial.println("Waiting for an ip address");
  while (WiFi.localIP() == INADDR_NONE) 
  {
    Serial.print(".");     // print dots while we wait for an ip addresss
    delay(300);
  }
  Serial.println("\nIP Address obtained");
}




//##### Main Program #####
void loop()  
{ 
  //Reconnect if we are not subscribed to the topic
  if (!client.connected()) { 
    Serial.println("Disconnected. Reconnecting....");
    delay(10000); //Wait 30 seconds between connection attempts
    if(!client.connect(mQTTID, mQTTUser, mQTTPassword)) {   //Comment out this line if you DON"T have a User or Password for the MQTT Broker 
  //if(!client.connect(mQTTID)) {                           //Comment out this line if you DO have a User or Password for the MQTT Broker 
      Serial.println("Connection failed");
    } else {
      Serial.println("Connection success");
      if(client.subscribe(topic)) {
        Serial.println("Subscription successfull");
      }
    }
  }

  ///// Evaluate input 13 and send a message if the value changes 
  if (digitalRead(12) != vInp13)
  {
   vInp13 = digitalRead(12);
   if (vInp13 == LOW)
   {    
     client.publish(topic, "BLUE_LED=LOW");
     Serial.println("TX: BLUE_LED=LOW");
   }
   else
   {
     client.publish(topic, "BLUE_LED=HIGH");
     Serial.println("TX: BLUE_LED=HIGH");
   }
  } 

  /////Evaluate ADC
 /* iA0 = analogRead(A0); // Read the analog value
  if (Counter >= 150)   // Counter reduces how often we update to help prevent broker spam
  {
    Counter = 0;
    //if (1==1)   //For testing and scaling,
    if (((iA0 * 1.02) < vA0) or ((iA0 * 0.98) > vA0))   //(Deadband)Only Update if the raw value is +- 10% 
    {
     vA0 = iA0;                               //Set the variables equal to eachother for next time comparison
     iA0 = ((iA0/9.76)+12);                  //Scale and offset the value to Degrees F https://www.youtube.com/watch?v=ub20R9WnH-g
     String str = (String)iA0;                //PubSubClient requires data to be a char* (char array) so we have to convert the int
     int str_len = str.length() +1;           //Length + null terminator
     char char_array[str_len];                //Prepare the character array (buffer)
     str.toCharArray(char_array, str_len);    // Copy it over 
     client.publish(topic, char_array); // Publish to MQTT
     Serial.print("TX: RAW: ");                    // Print to Seral window  
     Serial.print(vA0);    
     Serial.print("   Scaled: ");                    // Print to Seral window  
     Serial.println(iA0);        
    }  
  }  
  else
  {
    Counter++;
  }  */
 
  client.loop(); // Check if any subscribed messages were received
  delay(10);
}



//##### Subroutines #####
///// VOID CALLBACK - prints to the serial monitor if we recieve a MQTT message /////
void callback(char* topic, byte* payload, unsigned int length) 
{
  Serial.print("RX: ");
  //Convert and clean up the MQTT payload messsage into a String
  rx = String((char *)payload);                    //Payload is a Byte Array, convert to char to load it into the "String" object 
  rxLength = rx.length();                          //Figure out how long the resulting String object is 
  for (int i = length; i <= rxLength; i++)         //Loop through setting extra characters to null as garbage may be there
  {
    rx.setCharAt(i, ' ');
  }
  rx.trim();                                       //Use the Trim function to finish cleaning up the string   
  Serial.print(rx);                                //Print the recieved message to serial
  Serial.println();

  //Evaulate the recieved message to do stuff
  if (rx == "BLUE_LED=LOW"){
    digitalWrite(16, 1);
  } 
  if (rx == "BLUE_LED=HIGH"){
    digitalWrite(16, 0);
  } 

  
}



